#!/bin/sh
#Calcul_en_Pluie.tcl
#\
exec wish "$0" ${1+"$@"}
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jean-louis.sendral@toulouse.iufm.fr
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean-Louis Sendral
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *************************************************************************
# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [ mc {hello]
# ou bien : puts stdout [ mc {hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exists i18n(fr,$m)] } {
#    return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
# } ;# proc gettext

if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
}

proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}

bind . <F1> "showaide { }"


global sysFont
source calculs.conf
#source i18n
source msg.tcl
source fonts.tcl
source path.tcl
set plateforme $tcl_platform(platform) ; set ident $tcl_platform(user)
init $plateforme
#initlog $plateforme  $ident
set basedir [file dir $argv0]
cd $basedir
#utilit de ce cd ?
wm geometry . +0+0
. configure -background blue
##wm resizable . 0 0
wm title . [mc {Calculs}]
##. configure -background #ffff80

proc interface {} {
catch {destroy .menu}
catch {destroy .frame}
global tcl_platform basedir progaide
##wm geometry . +0+0
##. configure -background blue
##wm resizable . 0 0
##wm title . [mc {Calculs}]
##. configure -background #ffff80
set font {Arial 16}

########################
# 	Barre de menus	#
#-----------------------#

# Creation du menu utilise comme barre de menu:
menu .menu -tearoff 0

# Creation du menu Fichier
menu .menu.fichier -tearoff 0
.menu add cascade -label [mc {Fichier}] -menu .menu.fichier
.menu.fichier add command -label [mc {edit_scena_ment_appr} ] -command "lanceappli editeurp.tcl"
.menu.fichier add command -label [ mc {edit_seq_ment_appr}] -command "lanceappli editeurseq.tcl"
.menu.fichier add command -label [ mc {edit_division}] -command "lanceappli scenario_div.tcl "
 if {  $tcl_platform(platform) == "unix" } {
 menu .menu.fichier.bilan -tearoff 0
.menu.fichier add cascade -label [ mc {Bilans}]    -menu .menu.fichier.bilan
## -command "lanceappli bilan.tcl"
.menu.fichier.bilan add radio -label [mc {Bilan Calcul mental}] -variable bilan  -value m -command "lanceappli bilan_pluie.tcl"
.menu.fichier.bilan add radio -label [mc {Bilan Calcul arbre}] -variable bilan   -value a -command "lanceappli bilan_a.tcl"
 }
if  { $tcl_platform(platform) == "windows" }  {
 .menu.fichier add command  -label [mc {Bilans}]   -command "lanceappli bilan_pluie.tcl"
}
.menu.fichier add sep
.menu.fichier add command -label [ mc {quit}] -command exit

#menu .menu.option -tearoff 0
#.menu add cascade -label [mc {Options}] -menu .menu.option
#.menu.option add command -label [mc {Reglages}] -command "source reglages.tcl"

menu .menu.action -tearoff 0
.menu add cascade -label [ mc {Activits}] -menu .menu.action
.menu.action add command -label [ mc {Calcul_Mental}] -command "lanceappli choix.tcl"
.menu.action add command -label [ mc {Calcul_Approch} ] -command "lanceappli choix_app1.tcl"
.menu.action add command -label [ mc {Calcul_en_arbre} ] -command "lanceappli Calcul_en_arbre.tcl"
.menu.action add command -label [ mc {A_nous_la_Division} ] -command "lanceappli choix_div.tcl "
menu .menu.option -tearoff 0
.menu add cascade -label [mc {Reglages}] -menu .menu.option
set ext .msg
menu .menu.option.lang -tearoff 0 
.menu.option add cascade -label "[mc {Langue}]" -menu .menu.option.lang
foreach i [glob [file join  $basedir msgs *$ext]] {
set langue [string map {.msg ""} [file tail $i]]
.menu.option.lang add radio -label $langue -variable langue -command "setlang $langue"
}

##.menu add command -label "                  " -command ""
.menu add command -label [ mc {Aide} ]  -command       "exec $progaide  aide.html"
###showaide {}"
##  if {$plateforme == "windows"} {
##.menu add command -label [mc {Utilisateur}] -command "setwindowsusername"
###}

. configure -menu .menu
set normal "-background {} -relief flat"
################
# Image de fond #
#################
frame .frame -background blue -height 400 -width 200
pack .frame -expand true
set myimage [image create photo -file images/background.gif]
label .frame.imagedisplayer -image $myimage -background blue 
pack .frame.imagedisplayer  
###grid .frame.imagedisplayer -column 1 -row 0 -sticky e
}
############
# Bindings #
############
bind . <Control-q> {exit}



proc lanceappli {appli} {
    global iwish
    exec $iwish $appli &
}
proc setlang {lang} {
global env plateforme
set env(LANG) $lang
::msgcat::mclocale $lang
::msgcat::mcload [file join [file dirname [info script]] msgs]
interface
}
interface

#modifier wish pour PC windaube



