#!/bin/sh
#bilan.tcl
#\
exec wish "$0" ${1+"$@"}
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jean-louis.sendral@toulouse.iufm.fr
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean-Louis Sendral
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *************************************************************************
set basedir [file dir $argv0]
cd $basedir
source calculs.conf
source i18n
#cd $TRACEDIRX
# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exists i18n(fr,$m)] } {
#    return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
#} ;# proc gettext
if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
}

proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}
bind . <F1> "showaide {}"
global sysFont
source msg.tcl
source fonts.tcl
cd $TRACEDIR
# cd $dir_des_bilans (les classes = les groupes ?)
wm geometry . +0+0
wm title . [mc {bilan_elev}]

. configure  -height 480 -width 640 -background #808080
set font {Arial 10}

frame .frame1 -background #808080 -height 480 -width 260
grid .frame1 -column 0 -row 0
listbox .frame1.list1 -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".frame1.scroll1 set" \

scrollbar .frame1.scroll1 -command ".frame1.list1 yview"

place .frame1.list1 -x 20 -y 40
place .frame1.scroll1 -x 137 -y 40 -height 175
label .frame1.menu3 -text [mc {choix_elev}] -background #808080
place .frame1.menu3 -x 10 -y 5
label .frame1.menu4 -text [mc {double_clic}] -background #808080
place .frame1.menu4 -x 20 -y 20

bind .frame1.list1 <Double-ButtonRelease-1> "capturebilan"

frame .frame2 -background #ffff80 -height 480 -width 460
grid .frame2 -column 1 -row 0
text .frame2.text -yscrollcommand ".frame2.scroll set" -xscrollcommand ".frame2.scroll2 set" \
-setgrid true -width 50 -height 20 -font $font -wrap none -background #808080
scrollbar .frame2.scroll  -command ".frame2.text yview"
scrollbar .frame2.scroll2 -orient horizontal  -command ".frame2.text xview"

#place .frame2.text -x 0 -y 40
pack .frame2.scroll -side right -fill y
#place .frame2.scroll -x 440 -y 40 -height 460
#place .frame2.scroll2 -x 0 -y 460  -width 460
pack .frame2.scroll2 -side bottom  -fill x
pack .frame2.text -expand yes -fill both
proc dans { el liste } {
foreach el_gen $liste {
if { $el_gen == $el } {
return 1
}
}
return 0
}

proc capturenoms {} {
global nom_elev global file f
#set nom_elev [ .frame1.nom_elev get ]
set types {
    {"Catgories"		{.bil}	}
}
catch {set file [tk_getOpenFile -filetypes $types]}
if { [ catch { set f [open [file join $file] "r" ] } ] } {
set answer [tk_messageBox -message [mc {Erreur de fichier}] -type ok -icon info]
exit
}
#set liste_noms [exec  cut -d ":" -f3 $file ]
set liste_noms {}
while {[gets $f ligne] >=0} {
 set liste_noms [linsert $liste_noms 0 [lindex [split $ligne ":"] 2]]
}

set liste_noms [lsort $liste_noms ]
set liste_sans_doublons {}
foreach nom $liste_noms {
if { ! [dans $nom $liste_sans_doublons] } {
set liste_sans_doublons [linsert $liste_sans_doublons 0 $nom ]
.frame1.list1 insert end $nom
}
}
}
capturenoms
#label .frame1.nom -text "Taper le nom"
#place .frame1.nom -x 20 -y 10
#entry .frame1.nom_elev -width 10
#place .frame1.nom_elev -x 20 -y 30
#focus -force .nom_elev
#set types {
#    {"Catgories"		{.bil}	}
#}
#catch {set file [tk_getOpenFile -filetypes $types]}
#if { [ catch { set f [open [file join $file] "r" ] } ] } {
#set answer [tk_messageBox -message "Erreur de fichier" -type ok -icon info]
#exit
#}

proc capturebilan {} {
global file nom_elev f
#.frame2.text delete 1 end
set nom_elev [ .frame1.list1 get active ]
#if [catch {set bilan [exec grep $nom_elev $f ] } ] {
#set bilan "pas de bilan"
#}
set bilan {}
set f [open $file "r" ] 
.frame2.text delete 1.0 end
.frame2.text insert end "Bilans de $nom_elev de la classe [file tail [file rootname $file]] :"
.frame2.text insert end \n

while { ! [eof $f] } {
set ligne [gets  $f ] 
if {[ lsearch -exact [split $ligne ":" ] $nom_elev] >= 0} {
set bilan [ concat  [lrange [split $ligne ":" ] 1 4] $bilan ]
.frame2.text insert end [lrange [split $ligne ":" ] 1 7] 
.frame2.text insert end \n
}
}
}
#for {info = 1 } {info <= [llength [split $ligne ":" ] ] {incr info } {
#tab_info($nom_elev,$file,date) = [lindex [split $ligne ":" ] 1]
#tab_info($nom_elev,$file,bonne_rep) = [lindex [split $ligne ":" ] 5]
#.frame2.text insert end tab_info($nom_elev,$file,date) 
#if bilan .. set bilan "pas de bilan"
#.frame2.text delete 1.0 end
#.frame2.text insert end "Bilans de $nom_elev de la classe [file tail [file rootname $file]] :"
#.frame2.text insert end \n
#.frame2.text insert end $bilan

